Name:           zydis
Version:        4.0.0
Release:        %autorelease
Summary:        Fast and lightweight x86/x86-64 disassembler and code generation library

License:        MIT
URL:            https://github.com/zyantific/zydis
Source:         %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  gcc gcc-c++
BuildRequires:  cmake
BuildRequires:  zycore-c-devel
BuildRequires:  doxygen

%description
Zydis is fast and lightweight x86/x86-64 disassembler and code generation library.

- Supports all x86 and x86-64 (AMD64) instructions and extensions
- Optimized for high performance
- No dynamic memory allocation ("malloc")
- Thread-safe by design
- Very small file-size overhead compared to other common disassembler libraries
- Complete doxygen documentation
- Absolutely no third party dependencies — not even libc
  - Should compile on any platform with a working C11 compiler
  - Tested on Windows, macOS, FreeBSD, Linux and UEFI, both user and kernel mode

%package        devel
Summary:        Development libraries and header files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package        tools
Summary:        Tools for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description tools
The %{name}-tools package contains tools about %{name}.

%prep
%autosetup

%build
%cmake \
    -DZYAN_SYSTEM_ZYCORE=ON \
    -DZYDIS_BUILD_SHARED_LIB=ON \
%cmake_build

%install
%cmake_install

%check
cd tests/
./regression.py test ../%{_vpath_builddir}/ZydisInfo
./regression_encoder.py ../%{_vpath_builddir}/Zydis{Fuzz{ReEncoding,Encoder},TestEncoderAbsolute}

%files
%license LICENSE
%doc README.md
%{_datadir}/doc/Zydis
%{_libdir}/libZydis.so.4.0*

%files devel
%{_includedir}/Zydis/
%{_libdir}/cmake/zydis/
%{_libdir}/libZydis.so

%files tools
%{_bindir}/ZydisDisasm
%{_bindir}/ZydisInfo

%changelog
%autochangelog
